# This file was automatically generated by SWIG
package XML::JHXML;
require Exporter;
require DynaLoader;
@ISA = qw(Exporter DynaLoader);
package XML::JHXMLc;
bootstrap XML::JHXML;

# ------- CUSTOM PERL EXTENSION --------

package XML::JHXML;

use vars qw($VERSION);

$VERSION = "0.1.8";

use constant ELEMENT_NODE    => 1;
use constant ATTRIBUTE_NODE  => 2;
use constant TEXT_NODE	     => 3;
use constant DOCUMENT_NODE   => 9;
use constant NYI => "#NOT_YET_IMPLEMENTED";


sub new {
  my $class = ref($_[0]) || $_[0];
  $opts = NewParserOptions();
  return bless [$opts], $class;
}

sub recovering {
  my ($self,$value)=@_;
  return unless ref($self->[0]);
  if (@_>1) {
    $value = $value ? 1 : 0;
    SetOptionParseErrorsOK($self->[0],$value);
    return $value;
  } else {
    return ParserOptions_fParseErrorsOK_get($self->[0]);
  }
}

sub keep_blanks {
  my ($self,$value)=@_;
  return unless ref($self->[0]);
  if (@_>1) {
    if ($value == -1) {
      SetOptionNoBlanks($self->[0],2);
    } elsif ($value == 0) {
      SetOptionNoBlanks($self->[0],1);
    } elsif ($value == 1) {
      SetOptionNoBlanks($self->[0],0);
    } else {
      warn "JHXML: value $value for keep_blanks not supported\n";
    }
    return $value;
  } else {
    return ParserOptions_fNoBlanks($self->[0]);
  }
}

sub indent {
  my ($self,$value)=@_;
  return unless ref($self->[0]);
  if (@_>1) {
    SetOptionIndent($self->[0],$value-1);
    return $value;
  } else {
    return ParserOptions_iIndent($self->[0]);
  }
}

sub DESTROY {
  my ($self)=@_;
  DeleteParserOptions($self->[0]);
}

sub parse_file   {
  my ($self,$file)=@_;
  ParseFile($file,$self->[0]);
}

sub parse_string {
  ParseString($_[1], $_[0]->[0])
}

package XML::JHXML::Document;

sub nodeType { XML::JHXML->DOCUMENT_NODE };
sub getNodeType { XML::JHXML->DOCUMENT_NODE };
sub nodeName { "" };
sub toFile {
  XML::JHXML::WriteFile(@_);
}


*documentElement      = \&XML::JHXML::DocGetRootElement;
*getDocumentElement   = \&XML::JHXML::DocGetRootElement;
*createElement	      = \&XML::JHXML::CreateElement;
*createTextNode	      = \&XML::JHXML::CreateTextNode;

*destroy	      = \&XML::JHXML::DestroyDoc;

*_docSetAttribute     = \&XML::JHXML::DocSetAttribute;
*_docRemoveAttribute  = \&XML::JHXML::DocRemoveAttribute;
*_docAppendText	      = \&XML::JHXML::DocAppendText;

package XML::JHXML::Attr;

sub nodeType { XML::JHXML->ATTRIBUTE_NODE };
sub getNodeType { XML::JHXML->ATTRIBUTE_NODE };

# TO BE REIMPLEMENTED BY NATIVE LIBRARY WRAPPERS
*nodeName = \&XML::JHXML::Attr_pszName_get;
*value    = \&XML::JHXML::Attr_pszValue_get;
*setValue = \&XML::JHXML::Attr_pszValue_set;
*next     = \&XML::JHXML::GetNextAttr;

*getName = *nodeName;
*name = *nodeName;
*getValue = *value;

sub toString { 
  my ($self)=@_;
  $self->nodeName().'="'.$self->value().'" '
}


package XML::JHXML::Node;

sub nodeType {
  return $_[0]->isTextNode ? XML::JHXML->TEXT_NODE : XML::JHXML->ELEMENT_NODE;
}

*getNodeType	  = *nodeType;

*toString	  = \&XML::JHXML::ToString;
*parentNode	  = \&XML::JHXML::GetParent;
*getParentNode	  = \&XML::JHXML::GetParent;
*firstChild	  = \&XML::JHXML::GetFirstChild;
*getFirstChild	  = \&XML::JHXML::GetFirstChild;
*lastChild	  = \&XML::JHXML::GetLastChild;
*getLastChild	  = \&XML::JHXML::GetLastChild;
*nextSibling	  = \&XML::JHXML::GetNextElement;
*getNextSibling	  = \&XML::JHXML::GetNextElement;
*previousSibling    = \&XML::JHXML::GetPrevElement;
*getPreviousSibling = \&XML::JHXML::GetPrevElement;
*firstAttribute	  = \&XML::JHXML::GetFirstAttr;
*getAttribute	  = \&XML::JHXML::GetAttribute;
*setAttribute	  = \&XML::JHXML::SetAttribute;
*getData	  = \&XML::JHXML::GetData;

*nodeName	  = \&XML::JHXML::GetElementName;
*getNodeName	  = \&XML::JHXML::GetElementName;
*localname	  = \&XML::JHXML::GetElementName;
*getLocalName	  = \&XML::JHXML::GetElementName;
*isSameNode	  = \&XML::JHXML::IsSameNode;
*hasChildNodes	  = \&XML::JHXML::HasChildNodes;
*isTextNode	  = \&XML::JHXML::IsTextNode;

*insertBefore	  = \&XML::JHXML::InsertBefore;
*insertAfter	  = \&XML::JHXML::InsertAfter;
*appendChild	  = \&XML::JHXML::AppendChild;
*removeChild	  = \&XML::JHXML::RemoveChild;
*replaceChild	  = \&XML::JHXML::ReplaceChild;

*destroyThisNode  = \&XML::JHXML::DestroyNode;
*destroy	  = \&XML::JHXML::DestroySubtree;

*removeAttribute  = \&XML::JHXML::RemoveAttribute;
*setData	  = \&XML::JHXML::SetData;

*appendText	  = \&XML::JHXML::AppendText;
*appendTextChild  = \&XML::JHXML::AppendTextChild;

*findFirstChild   = \&XML::JHXML::FindFirstChild;
*findAncestor     = \&XML::JHXML::FindAncestor;
*findNextSibling  = \&XML::JHXML::FindNextSibling;
*findPreviousSibling  = \&XML::JHXML::FindPrevSibling;

sub getChildrenByTagName {
  my ($self,$name)=@_;
  if (wantarray) {
    my @ret;
    my $node=$self->findFirstChild($name);
    while ($node) {
      push @ret,$node;
      $node = $node->findNextSibling($name);
    }
    return @ret;
  } else {
    # optimized version
    my $ret=0;
    my $node=$self->findFirstChild($name);
    while ($node) {
      $ret++;
      $node = $node->findNextSibling($name);
    }
    return $ret;
  }
}

sub getElementsByTagName {
  my ($self,$name)=@_;
  if (wantarray) {
    my @ret;
    my $node=$self->firstChild();
    while ($node) {
      push @ret,$node
	if ($node->nodeType == XML::JHXML->ELEMENT_NODE
	    and ($name eq '*' or $node->nodeName() eq $name));
      $node = $node->followingNode($self);
    }
    return @ret;
  } else {
    # optimized version
    my $ret=0;
    my $node=$self->firstChild();
    while ($node) {
      $ret++ if ($node->nodeType == XML::JHXML->ELEMENT_NODE
		 and ($name eq '*'  or $node->nodeName() eq $name));
      $node = $node->followingNode($self);
    }
    return $ret;
  }
}

# convenient extension (not in DOM)
sub followingNode {
  my ($node,$top)=@_;
  if ($node->firstChild) {
    return $node->firstChild;
  }
  do {
    return $node->nextSibling if $node->nextSibling;
    $node = $node->parentNode;
    return undef if ($node and $node->isSameNode($top));
  } while ($node);
  return undef;
}

# convenient extension (not in DOM)
sub precedingNode {
  my ($node,$top)=@_;
  if ($node->previousSibling) {
    $node=$node->previousSibling;
    while ($node->hasChildNodes) {
      $node=$node->lastChild;
    }
    return $node;
  } elsif ($node->parentNode
	   and
	   !$node->parentNode->isSame($top)) {
    return $node->parentNode;
  } else {
    return undef;
  }
}

package XML::JHXML;

1;

# ------- SWIG GENERATED SHADOW CLASSES --------


package XML::JHXML;
@EXPORT = qw( );

# ---------- BASE METHODS -------------

package XML::JHXML;

sub TIEHASH {
    my ($classname,$obj) = @_;
    return bless $obj, $classname;
}

sub CLEAR { }

sub FIRSTKEY { }

sub NEXTKEY { }

sub FETCH {
    my ($self,$field) = @_;
    my $member_func = "swig_${field}_get";
    $self->$member_func();
}

sub STORE {
    my ($self,$field,$newval) = @_;
    my $member_func = "swig_${field}_set";
    $self->$member_func($newval);
}

sub this {
    my $ptr = shift;
    return tied(%$ptr);
}


# ------- FUNCTION WRAPPERS --------

package XML::JHXML;

*callback_err = *XML::JHXMLc::callback_err;
*callback_msg = *XML::JHXMLc::callback_msg;
*IsSameNode = *XML::JHXMLc::IsSameNode;
*HasChildNodes = *XML::JHXMLc::HasChildNodes;
*IsTextNode = *XML::JHXMLc::IsTextNode;
*AppendChild = *XML::JHXMLc::AppendChild;
*DocGetRootElement = *XML::JHXMLc::DocGetRootElement;
*GetNextElement = *XML::JHXMLc::GetNextElement;
*GetPrevElement = *XML::JHXMLc::GetPrevElement;
*GetFirstChild = *XML::JHXMLc::GetFirstChild;
*GetLastChild = *XML::JHXMLc::GetLastChild;
*GetParent = *XML::JHXMLc::GetParent;
*GetFirstAttr = *XML::JHXMLc::GetFirstAttr;
*GetNextAttr = *XML::JHXMLc::GetNextAttr;
*GetAttribute = *XML::JHXMLc::GetAttribute;
*GetAttributeNode = *XML::JHXMLc::GetAttributeNode;
*SetAttribute = *XML::JHXMLc::SetAttribute;
*GetData = *XML::JHXMLc::GetData;
*WriteFile = *XML::JHXMLc::WriteFile;
*ParseFile = *XML::JHXMLc::ParseFile;
*ParseString = *XML::JHXMLc::ParseString;
*GetElementName = *XML::JHXMLc::GetElementName;
*InsertBefore = *XML::JHXMLc::InsertBefore;
*InsertAfter = *XML::JHXMLc::InsertAfter;
*RemoveChild = *XML::JHXMLc::RemoveChild;
*ReplaceChild = *XML::JHXMLc::ReplaceChild;
*CreateElement = *XML::JHXMLc::CreateElement;
*CreateTextNode = *XML::JHXMLc::CreateTextNode;
*DestroyNode = *XML::JHXMLc::DestroyNode;
*DestroySubtree = *XML::JHXMLc::DestroySubtree;
*DestroyDoc = *XML::JHXMLc::DestroyDoc;
*DocSetAttribute = *XML::JHXMLc::DocSetAttribute;
*DocRemoveAttribute = *XML::JHXMLc::DocRemoveAttribute;
*RemoveAttribute = *XML::JHXMLc::RemoveAttribute;
*SetData = *XML::JHXMLc::SetData;
*DocAppendText = *XML::JHXMLc::DocAppendText;
*AppendText = *XML::JHXMLc::AppendText;
*DocAppendTextChild = *XML::JHXMLc::DocAppendTextChild;
*AppendTextChild = *XML::JHXMLc::AppendTextChild;
*FindFirstChild = *XML::JHXMLc::FindFirstChild;
*FindNextSibling = *XML::JHXMLc::FindNextSibling;
*FindPrevSibling = *XML::JHXMLc::FindPrevSibling;
*FindAncestor = *XML::JHXMLc::FindAncestor;
*NewParserOptions = *XML::JHXMLc::NewParserOptions;
*DeleteParserOptions = *XML::JHXMLc::DeleteParserOptions;
*SetOptionParseErrorsOK = *XML::JHXMLc::SetOptionParseErrorsOK;
*SetOptionNoBlanks = *XML::JHXMLc::SetOptionNoBlanks;
*SetOptionIndent = *XML::JHXMLc::SetOptionIndent;
*ToString = *XML::JHXMLc::ToString;

############# Class : XML::JHXML::Attr ##############

package XML::JHXML::Attr;
@ISA = qw( XML::JHXML );
%OWNER = ();
%ITERATORS = ();
*swig_pszName_get = *XML::JHXMLc::Attr_pszName_get;
*swig_pszName_set = *XML::JHXMLc::Attr_pszName_set;
*swig_pszValue_get = *XML::JHXMLc::Attr_pszValue_get;
*swig_pszValue_set = *XML::JHXMLc::Attr_pszValue_set;
sub new {
    my $pkg = shift;
    my $self = XML::JHXMLc::new_Attr(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        XML::JHXMLc::delete_Attr($self);
        delete $OWNER{$self};
    }
}

sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


############# Class : XML::JHXML::ParserOptions ##############

package XML::JHXML::ParserOptions;
@ISA = qw( XML::JHXML );
%OWNER = ();
%ITERATORS = ();
*swig_szCode_get = *XML::JHXMLc::ParserOptions_szCode_get;
*swig_szCode_set = *XML::JHXMLc::ParserOptions_szCode_set;
*swig_fParseErrorsOK_get = *XML::JHXMLc::ParserOptions_fParseErrorsOK_get;
*swig_fParseErrorsOK_set = *XML::JHXMLc::ParserOptions_fParseErrorsOK_set;
*swig_fNoBlanks_get = *XML::JHXMLc::ParserOptions_fNoBlanks_get;
*swig_fNoBlanks_set = *XML::JHXMLc::ParserOptions_fNoBlanks_set;
*swig_iIndent_get = *XML::JHXMLc::ParserOptions_iIndent_get;
*swig_iIndent_set = *XML::JHXMLc::ParserOptions_iIndent_set;
sub new {
    my $pkg = shift;
    my $self = XML::JHXMLc::new_ParserOptions(@_);
    bless $self, $pkg if defined($self);
}

sub DESTROY {
    return unless $_[0]->isa('HASH');
    my $self = tied(%{$_[0]});
    return unless defined $self;
    delete $ITERATORS{$self};
    if (exists $OWNER{$self}) {
        XML::JHXMLc::delete_ParserOptions($self);
        delete $OWNER{$self};
    }
}

sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
}

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
}


# ------- VARIABLE STUBS --------

package XML::JHXML;

1;
