
# -*- perl -*-
# This script is an attempt to automatically find possible coreferents
# in TGTS structures for Czech.
# contributed to TrEd by Oliver Culo in 12/2003

# Completely substituted by Zdenek Zabokrtsky'code in 4/2004

package ACAP;


# listst of control verbs

my $control_ADDR='(brnit|dt|donutit|dopomoci|doporuit|doporuovat|dovolit|dovolovat|motivovat|nadit|nauit|navrhnout|navrhovat|nutit|podait_se|pomhat|pomoci|povit|povolit|povolovat|poadovat|pedepsat|pikzat|pimt|pinutit|stait|stt|ukldat|uloit|umonit|umoovat|urit|vypomoci|zabrnit|zabraovat|zakzat|zakazovat|zapovdat|zavazovat|zmocnit|znemonit|znemoovat)';

my $control_PAT='(bavit|bt|donutit|nauit|nechat|nechvat|nutit|oprvnit|osvdovat_se|podait_se|pipravit|snait_se|spatit|stait|kodit|unavovat|vadit|vidt|vyplatit_se|zbt|zbvat)';

my $control_BEN='(bt|bvat|jt|lze|odmtat|oznait|povaovat|snait_se|stt|uznat|vyplatit_se|zdt_se|znamenat)';

my $control_ACT='(bt_se|ctit_se|asit|dait_se|dt|dt|dt_se|dvat|dojt|dokzat|dostat|dovst|dovolit_si|dovolovat_si|dozvdt_se|hodlat|hrozit|chodit|chtt|chtt_se|chystat_se|jet|jevit_se|jezdit|klst|koukat|mnit|mt|moci|naklonit|namhat_se|napadnout|nauit_se|nechat_se|nechvat|nechvat_se|odejt|odhodlat|odhodlat_se|odltat|odmtat|odmtnout|odnauit_se|odvit_se|opomenout|oprvnit|ostchat_se|plnovat|podait_se|pokouet_se|pokusit|pokusit_se|pomhat|potebovat|povaovat|povst_se|pt_si|pestat|pestvat|pichzet|pijet|pijt|pijt_si|pijdt|pipravit|pislbit|psluet|rozhodnout|rozhodnout_se|rozmyslit_si|snait_se|spchat|stihnout|svst|touit|troufat_si|troufnout_si|uit_se|ukzat_se|ukazovat_se|umt|usilovat|uznat|vhat|vdt|vyhbat_se|vytknout_si|zanat|zat|zakzat|zapomenout|zapomnat|zaslouit_si|zatouit|zavzat_se|zbt|zkouet|zkusit|znamenat|znemoovat|zstat|zstvat|zvldnout|zvyknout_si)';

# ------------------------------------------------------------------------------
# --------  function for automatic assignment of grammatical coreference -------

sub autoAssignCorefs ($) {

  my $node=shift || $this;
  return unless ($node->parent and $node->parent->parent);
  my $parent=$node->parent;
  my $grandpa=$parent->parent;
  my ($lparent)=(PDT::GetFather_TR($node));
  my $antec;

  #  -------------------- gramaticka kontrola -------------------------------
  if ($node->{trlemma} eq '&Cor;' and $parent->{tag}=~/^Vf/ and $grandpa->{tag}=~/^V/) {
    if ($grandpa->{trlemma}=~/^$control_BEN$/) {
      ($antec)=(grep {$_->{func} eq "BEN"} $grandpa->children);
    }
    if (not $antec and $grandpa->{trlemma}=~/^$control_ADDR$/) {
      ($antec)=(grep {$_->{func} eq "ADDR"} $grandpa->children);
    }
    if (not $antec  and $grandpa->{trlemma}=~/^$control_ACT$/) {
      ($antec)=(grep {$_->{func} eq "ACT"} $grandpa->children);
    }
  }

  # ------------------- zvratna zajmena -------------------
  elsif ($node->{trlemma} eq "se" and $node->{func} ne "DPHR") {
    my $par=$node;
    while ($par->parent) {
      my $child=$par;
      $par=$par->parent;
      my @children= PDT::GetChildren_TR($par);
      my ($act)= grep {$_->{afun} eq "Sb" and $_ ne $child and $_ ne $node} @children;
      if (not $act) {($act)= grep {$_->{func} eq "ACT" and $_ ne $child and $_ ne $node} @children; }
      if ($act) {
	if (PDT::is_member_TR($act)) {$act=$act->parent}
	$antec=$act;
	last;
      }
    }
  }

 # -------- vztazne vedlejsi vety
 elsif ($node->{trlemma}=~/^(kter|jak|jen|kdy|kde|co|kdo)$/ and $lparent
	and $lparent->{tag}=~/^V/ and $lparent->{func} eq "RSTR") {
   my ($lgrandpa)=(PDT::GetFather_TR($lparent));
   if ($lgrandpa and $lgrandpa->{tag}=~/^[PN]/) {
     my %path_to_root;
     my $n=$node;
     while ($n->parent) {
       $path_to_root{$n}=1;
       $n=$n->parent
     };
     $n=$lgrandpa;
     while ($n->parent) {
       if ($path_to_root{$n}) {$antec=$n;last}
       $n=$n->parent;
     }
   }
 }

 # -------- vztazne vedlejsi vety s privlastnovacim vztaznym zajmenem (clovek, v jehoz dome...)
 elsif ($node->{trlemma}=~/^(jen)$/ and $lparent and $lparent->{tag}=~/^N/) {
   my ($lgrandpa)=(PDT::GetFather_TR($lparent));
   if ($lgrandpa
       and $lgrandpa->{func} eq "RSTR"
       and $lgrandpa->{tag}=~/^V/
      ) {
     my ($lggrandpa)=(PDT::GetFather_TR($lgrandpa));
     if ($lggrandpa and $lggrandpa->{tag}=~/^[PN]/) {
       my %path_to_root;
       my $n=$node;
       while ($n->parent) {
	 $path_to_root{$n}=1;
	 $n=$n->parent
       };
       $n=$lggrandpa;
       while ($n->parent) {
	 if ($path_to_root{$n}) {$antec=$n;last}
	 $n=$n->parent;
       }
     }
   }
 }

  # ------------------ jmenne doplnky ve shode se subjektem -------------------------
  elsif ($node->{func} eq "COMPL" and $node->{tag}=~/^(AC|((NN|PL|AA|C[rl])..1))/) {
    my ($parent)=(PDT::GetFather_TR($node));
    my @children= PDT::GetChildren_TR($parent);
    my ($act)= grep {$_->{afun} eq "Sb" and $_ ne $child and $_ ne $node} @children;
    if (not $act) {
	($act)= grep {$_->{func} eq "ACT" and $_ ne $child and $_ ne $node} @children;
      }
    if ($act) {
      if (PDT::is_member_TR($act)) {$act=$act->parent}
      $antec=$act;
    }
  }

  # ------------------ jmenne doplnky ve shode s objektem -------------------------
  elsif ($node->{func} eq "COMPL" and $node->{tag}=~/^(NN|AA)..4/) {
    my ($parent)=(PDT::GetFather_TR($node));
    my @children= PDT::GetChildren_TR($parent);
    my ($obj)= grep {$_->{tag}=~/^.[^7]..4/ and $_ ne $child and $_ ne $node} @children;
    if ($obj) {
      if (PDT::is_member_TR($obj)) {$obj=$obj->parent}
      $antec=$obj;
    }
  }

  if ($antec) {
    my $antecid=$antec->{TID} || $antec->{AID};
    return ($antecid,'autogrammatical')
  }  else {
    return undef
  }
}

# ------------------------------------------------------------------------------
# ----------- function for detecting coreference `candidates' ------------------ 

sub corefCandidate {
  my $node=shift || $this;
  my $depth;
  my $x=$node; while ($x->parent) {$depth++;$x=$x->parent}
  return unless $node;
  my ($parent)=(PDT::GetFather_TR($node));
  return ($node->{func}!~/(ETHD|DPHR|INTF|EXT)/ and
	  (
	   $node->{trlemma}=~/^(Cor|\&Cor|\&Cor;|\&Rcp;|.?QCor.?|on|se)$/
	   or ($node->{trlemma}=~/^(ten|tent|t|tento|tenhle)$/ and
	       $node->{func}!~/(RSTR|DIFF)/
	       and not (grep {
		 $_->{sentord}==$node->{sentord}+2 and
		   ($_->{trlemma}=~/^(kdo|co|kter|jak|jak|jen)$/ or # ten, kdo...
		    $_->{tag}=~/^J,/) # to, ze....
		 } $node->root->descendants()
		       )
	      )
	   or ($node->{trlemma}=~/^(jen|jak|kdy|kam|kudy|kde|kdo|co|co|tenhle|odkud|odkdy)$/
	       and $node->{ord}>2
	       and not ($parent->{func}=~/(EFF|PAT)/ and $parent->{tag}=~/^V/)
	       and $depth>2
	      )
	   or ($node->{trlemma}=~/^(kter|jak)$/
	       and not $parent->{tag}=~/^N/
	       and $depth>2
	      )

	   or $node->{func}=~/^COMPL/
	  )
	 )
}

1;

