# -*- cperl -*-

## Contains all code of PML package, suitable to be included.
## Should be included at the very beginning of a macro file.

#encoding iso-8859-2

BEGIN
{
	import PML;
}

=item detect()

Returns true if the current file is an English PDT p-file

=cut

sub detect {
  return (PML::SchemaDescription() =~ m{^English PDT} and PML::SchemaName() eq 'pdata') ? 1 : 0;
}

sub allow_switch_context_hook {
  return 'stop' unless detect();
}

sub enable_attr_hook { return 'stop'; }

sub enable_edit_node_hook { return 'stop'; }

sub allow_switch_context_hook {
  return 'stop' if SchemaName() !~ /^pdata$/;
}

sub switch_context_hook{
  my $cur_stylesheet = GetCurrentStylesheet();
  SetCurrentStylesheet('PML_En_P') if $cur_stylesheet ne 'PML_En_P';
}

=item AnalyticalTree()

This function is only available in TrEd (i.e. in GUI). After a
previous call to C<AnalyticalTree>, it switches current view back to
a analytical tree which refers to the current analytical tree.

=cut

sub AnalyticalTree {
  return unless SchemaName() =~ /^pdata$/;
  return unless SwitchToAFile();
  my $arf=$PML::arf;
  my $fsfile = $grp->{FSFile};
  my $id = $root->{id};
  my $this_id = $this->{id};
  SwitchContext('PML_En_A');
  if(ref $arf){
    $this=$grp->{currentNode};
    my($node,$treeno)=SearchForNodeById($arf->{id});
	TredMacro::GotoTree($treeno);
    $this=$node;
  }else{
    #find current tree and new $this
    my $trees = $fsfile->treeList;
    # low-level stuff here
    my $treeNo = $fsfile->currentTreeNo+0;
     TREE: for (my $i=0;$i<=$#$trees;$i++) {
         foreach my $p_rf (PML_En_A::GetPNodeIDs($trees->[$i])) {
           $p_rf =~ s/^.*\#//;
           if ($p_rf eq $id) {
             $treeNo = $i;
             last TREE;
           }
         }
     }
	 TredMacro::GotoTree($treeNo+1); # changes $root
     my $node=$root;
     while ($node) {
       if (first { $_ eq $this_id } PML_En_A::GetPNodeIDs($node)) {
         $this = $node;
         last;
       }
     } continue {
       $node = $node->following;
     };
  }
  ChangingFile(0);
}

sub SwitchToAFile {
  my $fsfile = $grp->{FSFile};
  return 0 unless $fsfile or PML::SchemaName() !~ /^pdata$/;
  my $ar_fs = $fsfile->appData('adata');
  if (!$ar_fs)
  {
    $ar_fs = HackToAFile();
  }
  return 0 unless ref($ar_fs);
  $grp->{FSFile} = $ar_fs;
  return 1;
}

sub HackToAFile
{
  my $file_name = FileName();
  $file_name =~ s/\.p.gz$/\.a.gz/;
  my ($req_fs,$status2) = main::openFile($grp,$file_name,-preload => 1);
  return $req_fs;
}

sub TectogrammaticalTree {
   AnalyticalTree();
   PML_En_A::TectogrammaticalTree();
}

