# -*- cperl -*-

#ifndef PML_En_T
#define PML_En_T

#include <contrib/pml/PML.mak>
#include <contrib/eng-vallex/contrib.mac>
#include <contrib/pml/PML_T_Edit.mak>

package PML_En_T;

#include "PML_En_T.inc"

#key-binding-adopt PML_T_Edit
#menu-binding-adopt PML_T_Edit

#unbind-key e
#unbind-key s
#unbind-key G
#unbind-key N
#unbind-key P
#unbind-key F
#unbind-key t
#unbind-key Alt+j
#unbind-key j
#unbind-key J
#unbind-key Ctrl+j
#unbind-key Alt+v

#remove-menu Change is_parenthesis
#remove-menu Show valency frames and highlight assigned
#remove-menu Jump to complement coreference antecedent
#remove-menu Jump to textual coreference antecedent
#remove-menu Annotate Special Coreference - Segment
#remove-menu Edit Node Type
#remove-menu Insert New Node
#remove-menu Edit TFA
#remove-menu Jump to grammatical coreference antecedent
#remove-menu Jump to coreference antecedent
#remove-menu Edit Grammatemes
#remove-menu Show effective ancestors
#remove-menu Annotate Special Coreference - Exophora

#bind PhrasalTree to Ctrl+P menu Display corresponding phrasal tree
#bind TLemmaCor to Alt+a menu Assign t_lemma #Cor
#bind TLemmaPersPron to Alt+A menu Assign t_lemma #PersPron
#bind TLemmaGen to Alt+c menu Assign t_lemma #Gen
#bind TLemmaUnsp to Alt+C menu Assign t_lemma #Unsp
#bind TLemmaVerbPron to Alt+b menu Assign t_lemma #VerbPron
#bind TLemmaOblfm to Alt+j menu Assign t_lemma #Oblfm
#bind MarkForARf to + menu Mark for reference changes and enter A-layer
#bind AnalyticalTree to Ctrl+A menu Display corresponding analytical tree
#bind OpenValLexicon to Ctrl+Shift+Return menu Browse valency frame lexicon
#bind ChooseValFrame to Ctrl+Return menu Select and assign valency frame
#bind AddENode to Insert menu Insert New #-Entity Node

#bind remove_all_from_aux to KP_Subtract menu Remove All From Aux
#bind remove_all_from_aux to minus

#include "checks.inc"
#bind check_file to Ctrl+l menu Check whole file
#bind check_tree to Ctrl+k menu Check current tree
#bind check_node to Ctrl+j menu Check current node
#bind ignore_current_error to Ctrl+g menu Ignore current error
#bind goto_next_error to Ctrl+b menu Go to next error

#bind RegenerateTLemma to Alt+L menu Regenerate T-lemma
#bind TLemmaFromForms to Alt+F menu Generate T-lemma from Forms
#bind AddComment to ! menu Add Annotator's comment
#bind EditComment to ? menu Edit Annotator's Comment
#bind EditVerbPatt to Alt+v menu Edit Verb Patterns
#bind AddNeg to Ctrl+h menu Add Negation
#bind AddEmpVerb to Ctrl+r menu Add EmpVerb
#bind AddEmpNoun to Ctrl+u menu Add EmpNoun
#bind EditFunctor to Ctrl+f menu Edit Functor
#bind RotateState to Alt+S menu Rotate State
#bind RotateDsp to Alt+d menu Rotate is_dsp_root
#bind EditTLemma to Alt+l menu Edit t_lemma
#bind AddANode to Shift+Insert menu Insert New Node from A-layer
#bind DeleteNodeToAux to Shift+Delete menu Delete Node Moving to Aux
#bind RotateParenthesis to Alt+P menu Change is_parenthesis
#bind RotateParenthesisSubtree to Alt+p menu Change is_parenthesis for Subtree
#bind AddForn to Ctrl+i menu Add #Forn.ID
#bind AddNewNode to Ctrl+w menu Add #NewNode.VOCAT
#bind Toggle3rdLine to Ctrl+a menu Toggle Display 3rd line
#bind RotateGenerated to Alt+r menu Change is_generated
#bind RotateMember to Alt+m menu Change is_member
#bind ClearValframe to Ctrl+F menu Clear Valency Frame

#bind FuncRSTR to r menu Assign RSTR
#bind FuncACT to A menu Assign ACT
#bind FuncPAT to P menu Assign PAT
#bind FuncPRED to p menu Assign PRED
#bind FuncCONJ to c menu Assign CONJ
#bind FuncLOC to l menu Assign LOC
#bind FuncTWHEN to t menu Assign TWHEN
#bind FuncRHEM to h menu Assign RHEM
#bind FuncDENOM to n menu Assign DENOM
#bind FuncMANN to m menu Assign MANN
#bind FuncEXT to x menu Assign EXT
#bind FuncID to I menu Assign ID
#bind FuncMAT to M menu Assign MAT
#bind FuncDIR3 to 3 menu Assign DIR3
#bind FuncDIR1 to 1 menu Assign DIR1
#bind FuncBEN to b menu Assign BEN
#bind FuncFPHR to 6 menu Assign FPHR
#bind FuncPREC to e menu Assign PREC
#bind FuncCRIT to K menu Assign CRIT
#bind FuncCAUS to C menu Assign CAUS
#bind FuncREG to g menu Assign REG
#bind FuncTHL to u menu Assign THL
#bind FuncADVS to 7 menu Assign ADVS
#bind FuncTHO to v menu Assign THO
#bind FuncCOMPL to k menu Assign COMPL
#bind FuncCOND to o menu Assign COND
#bind FuncOPER to 0 menu Assign OPER
#bind FuncAUTH to U menu Assign AUTH
#bind FuncCSQ to q menu Assign CSQ
#bind FuncSUBS to B menu Assign SUBS
#bind FuncTFRWH to W menu Assign TFRWH
#bind FuncTOWH to w menu Assign TOWH
#bind FuncDIR2 to 2 menu Assign DIR2
#bind FuncVOCAT to F9 menu Assign VOCAT
#bind FuncAPP to a menu Assign APP
#bind FuncADDR to D menu Assign ADDR
#bind FuncEFF to E menu Assign EFF
#bind FuncPAR to V menu Assign PAR
#bind FuncAPPS to 8 menu Assign APPS
#bind FuncACMP to Y menu Assign ACMP
#bind FuncAIM to i menu Assign AIM
#bind FuncMEANS to s menu Assign MEANS
#bind FuncCM to X menu Assign CM
#bind FuncDIFF to d menu Assign DIFF
#bind FuncCPHR to 4 menu Assign CPHR
#bind FuncCPR to j menu Assign CPR
#bind FuncTSIN to z menu Assign TSIN
#bind FuncTPAR to y menu Assign TPAR
#bind FuncORIG to O menu Assign ORIG
#bind FuncMOD to Q menu Assign MOD
#bind FuncATT to T menu Assign ATT
#bind FuncCNCS to N menu Assign CNCS
#bind FuncCONFR to 9 menu Assign CONFR
#bind FuncCONTRA to Ctrl+x menu Assign CONTRA
#bind FuncCONTRD to Ctrl+y menu Assign CONTRD
#bind FuncDISJ to J menu Assign DISJ
#bind FuncDPHR to 5 menu Assign DPHR
#bind FuncGRAD to G menu Assign GRAD
#bind FuncHER to H menu Assign HER
#bind FuncINTF to F menu Assign INTF
#bind FuncINTT to Z menu Assign INTT
#bind FuncPARTL to F1 menu Assign PARTL
#bind FuncREAS to F8 menu Assign REAS
#bind FuncRESL to R menu Assign RESL
#bind FuncRESTR to S menu Assign RESTR
#bind FuncTFHL to f menu Assign TFHL
#bind FuncTTILL to L menu Assign TTILL
#bind FuncDESCR to F10 menu Assign DESCR
#bind FuncSM to Ctrl+m menu Assign SM
#bind FuncNE to Ctrl+t menu Assign NE

#bind AnnotateSegm to Ctrl+S menu Annotate Special Coreference - Segment
#bind AnnotateExoph to Ctrl+E menu Annotate Special Coreference - Exophora


1;

#endif PML_En_T

