# -*- cperl -*-
package PML_A_View;

#binding-context PML_A_View
#bind ShowTNodes to t menu Show t-nodes
#binding-context PML_A_Edit
#bind PML_A_View->ShowTNodes to t menu Show t-nodes
sub ShowTNodes{
  my $aid = $this->{id};
  my $num = CurrentTreeNumber();
  my @nodes;
  ChangingFile(0);
  TectogrammaticalTree() or return;
  foreach my $node ( GetTrees() ){
    while ($node) {
      if ( grep { s/^.*?#//;/^$aid$/ }
           $node->attr('a/lex.rf'),ListV($node->attr('a/aux.rf')) ) {
        push @nodes,$node;
      }
      $node=$node->following
    }
  }
  if ( @nodes ) {
    my @lemmas = map { ($_->{t_lemma})
                         .'.'.($_->{functor}).' : '.($_->{id})} @nodes;
    my $d = [[]];
    my@toBeCleared;
    if(main::listQuery
       ($grp->toplevel,
        'Select Node',
        'multiple',
        \@lemmas,
        $d,
        buttons=>[{-text=>'Delete',
                   -underline=>0,
                   -command=>
                   [sub{
                      my($l)=@_;
                      foreach my $sel(reverse $l->curselection){
                        my$line=$l->get($sel);
                        $line =~ s/.* : //;
                        my($node)=SearchForNodeById($line);
                        push @toBeCleared,$node;
                        $l->delete($sel);
                      }
                    }
                   ]}]
       )){
      if(@toBeCleared){
        SetFileSaveStatus(1);
        SaveUndo('Delete a/*.rf reference');
        foreach my$node(@toBeCleared){
          my $refid = CurrentFile()->metaData('refnames')->{adata};
          if($node->attr('a/lex.rf') eq $refid.'#'.$aid){
            delete $node->{a}{'lex.rf'};
          }
          @{$node->{a}{'aux.rf'}}
            =uniq(ListSubtract
                  ($node->{a}{'aux.rf'},
                   List($refid.'#'.$aid)
                  )) if ListV($node->attr('a/aux.rf'));
        }
      }
      my $id = $d->[0];
      if($id){
        $id =~ s/.* : //;
        my ($node,$tree)=SearchForNodeById($id);
        TredMacro::GotoTree($tree);
        $this=$node;
        return 1;
      }else{ # do not get lost
        $this=$root;
      }
    }
  }
  PML_T::AnalyticalTree();
  my ($node,$tree)=SearchForNodeById($aid);
  TredMacro::GotoTree($tree);
  $this=$node;
}#ShowTNodes
