# -*- cperl -*-

package PML_Cz_T_Anot;

#binding-context PML_Cz_T_Anot
#include "PML_T_Anot.mak"

#encoding iso-8859-2

#ifdef anot_only
#ifdef TRED
register_start_hook(sub {
  if(ref $grp->{framegroup}->{UserMenu}){ # skip if called from print.btred
    my $usermenu = $grp->{framegroup}->{UserMenu};
    $usermenu = $usermenu->menu if $usermenu->isa('Tk::Menu::Cascade');
    for my $idx (reverse(0..$usermenu->index('last'))) {
      next if eval { $usermenu->entrycget($idx,'-label') =~ /PML_.*_Anot/ } ;
      $usermenu->delete($idx);
    }
  }
}); #start_hook
#endif TRED
#endif anot_only

#bind Reflexive to Alt+i menu Reflexive se/si
sub Reflexive {
  ChangingFile(0);
  if($this->{t_lemma}=~/_s[ei](?:\b|_)/){
    $this->{t_lemma}=~s/_s[ei](\b|_)/$1/;
    ChangingFile(1);
    VallexWarning($this);
  }else{
    my@anodes=grep{$_->attr('m/form')=~/^s[ei]$/i}GetANodes($this);
    if(@anodes==0){
      my$q=questionQuery
        ('se/si',
         'No "se" nor "si" found among analytical nodes.',
         'Add se','Add si','Cancel');
      if($q=~/Add (s[ei])/){
        $this->{t_lemma}.='_'.$1;
        ChangingFile(1);
        VallexWarning($this);
      }
    }elsif(@anodes==1){
      $this->{t_lemma}.='_'.lc($anodes[0]->attr('m/form'));
      ChangingFile(1);
      VallexWarning($this);
    }else{ # more than 1 anodes
      if(grep{$_->attr('m/form')=~/se/i}@anodes
         and grep{$_->attr('m/form')=~/si/i}@anodes){
        my$q=questionQuery
          ('se/si',
           'Both "se" and "si" found among analytical nodes.',
           'Add se','Add si','Cancel');
        if($q=~/Add (s[ei])/){
          $this->{t_lemma}.='_'.$1;
          ChangingFile(1);
          VallexWarning($this);
        }
      }else{
        $this->{t_lemma}.='_'.lc($anodes[0]->attr('m/form'));
        ChangingFile(1);
        VallexWarning($this);
      }
    }
  }
}#Reflexive

sub ToBeFrame {
  ChangingFile(0);
  if ($this->{t_lemma} eq 'bt'){
    $this->{'val_frame.rf'} = $_[0];
    ChangingFile(1);
  }
} # ToBeFrame

#bind CopulaFrame to Ctrl+b menu Assign Frame with Copula
sub CopulaFrame {
  ToBeFrame('v#v-w243f80_ZU');
} # CopulaFrame

#bind ExistentialFrame to Ctrl+B menu Assign Existential Frame
sub ExistentialFrame {
  ToBeFrame('v#v-w243f2');
} # ExistentialFrame

sub SetSemPOS {
    ChangingFile(0);
    return if substr($this->{t_lemma},0,1) eq '#';
    return if $this->{nodetype} ne 'complex';
    ChangingFile(1);
    $this->{gram}{sempos} = $_[0];
} # SetSemPOS

#bind SetPOSToN   to ALT+j menu Set SemPOS to N
#bind SetPOSToAdj to ALT+a menu Set SemPOS to Adj
#bind SetPOSToAdv to ALT+v menu Set SemPOS to Adv
#bind SetPOSToV   to ALT+s menu Set SemPOS to V
#bind SetPOSToAQ  to ALT+q menu Set SemPOS to Adj.Quant
#bind SetPOSToNQ  to ALT+Q menu Set SemPOS to N.Quant

sub SetPOSToN{
    SetSemPOS('n.denot');
} # SetPOSToN
sub SetPOSToAdj{
    SetSemPOS('adj.denot');
} # SetPOSToAdj
sub SetPOSToAdv{
    SetSemPOS('adv.denot.grad.neg');
} # SetPOSToAdv
sub SetPOSToV{
    SetSemPOS('v');
} # SetPOSToV
sub SetPOSToAQ{
    SetSemPOS('adj.quant.def');
} # SetPOSToAQ
sub SetPOSToNQ{
    SetSemPOS('n.quant.def');
} # SetPOSToNQ
