# -*- cperl -*-

package Czech_to_English;
#binding-context Czech_to_English
#key-binding-adopt TredMacro

BEGIN { import TMT; }

sub allow_switch_context_hook {
  return 'stop' if not TMT::is_tmt_file();
}

sub switch_context_hook {
  SetCurrentStylesheet('Czech_to_English');
  Redraw() if GUI();
}

sub get_value_line_hook {
  my ($fsfile,$treeNo)=@_;
  return unless $fsfile;
  my $bundle = $fsfile->tree($treeNo);
  return unless $bundle;

  return $bundle->attr('czech_source_sentence')."\n".
    $bundle->attr('english_source_sentence')."\n".
    $bundle->attr('english_target_sentence');
}

sub get_nodelist_hook {
  my ($fsfile, $treeNo, $currentNode, $hidden)=@_;
  my $bundle = $fsfile->tree($treeNo);
  my $ord = FS()->order;

  my @nodes = get_all_nodes_to_display($bundle);

  #print "Ord uzlu:\n";
  #print join " ",map{"o=$_->{ord}"} @nodes;
  #print "\n";
  $currentNode=$nodes[0] unless first { $_==$currentNode } @nodes;
  return [\@nodes, $currentNode];
}

sub get_all_nodes_to_display {
  my $bundle = shift;

  my ($sm_trees,
        $sn_trees,
        $sp_trees,
        $sa_trees,
        $st_trees,
        $tt_trees,
        $ta_trees) = TMT::group_nodes_by_direction_and_layer($bundle);

    return (
        $bundle,
        TMT::_interleave(@$tt_trees, @$st_trees),
        TMT::_interleave(@$ta_trees, @$sa_trees),
        TMT::_interleave(@$sm_trees),
        TMT::_interleave(@$sn_trees),
        TMT::_interleave(@$sp_trees)
    );
}
