# -*- cperl -*-

package Synthesis_en;
#binding-context Synthesis_en
#key-binding-adopt TredMacro

BEGIN { import TMT; }

sub allow_switch_context_hook {
  return 'stop' if not TMT::is_tmt_file();
}

sub switch_context_hook {
  SetCurrentStylesheet('Synthesis_en');
  Redraw() if GUI();
}

sub get_value_line_hook {
  my ($fsfile,$treeNo)=@_;
  return "nic" unless $fsfile;
  my $bundle = $fsfile->tree($treeNo);
  return "nic2" unless $bundle;

  if ($bundle->attr('trees/TEnglishA')) {
  	return $bundle->attr('english_source_sentence')."\n".
  	$bundle->attr('english_target_sentence');
  }
}

sub get_nodelist_hook {
  my ($fsfile, $treeNo, $currentNode, $hidden)=@_;
  my $bundle = $fsfile->tree($treeNo);
  my $ord = FS()->order;

  my @nodes = get_all_nodes_to_display($bundle);

  $currentNode=$nodes[0] unless first { $_==$currentNode } @nodes;
  return [\@nodes, $currentNode];
}

sub get_all_nodes_to_display {
  my $bundle = shift;

  my ($sm_trees,
      $sn_trees,
      $sp_trees,
      $sa_trees,
      $st_trees,
      $tt_trees,
      $ta_trees) = TMT::group_nodes_by_direction_and_layer($bundle);

  return (
      $bundle,
      TMT::_interleave(@$tt_trees, @$st_trees),
      TMT::_interleave(@$ta_trees, @$sa_trees),
      TMT::_interleave(@$sm_trees),
      TMT::_interleave(@$sn_trees),
      TMT::_interleave(@$sp_trees)
  );
}

